package com.ether;

import com.ether.annotation.ControllerMethod;
import com.ether.annotation.ParamName;
import net.sf.json.JSONObject;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jetbrains.annotations.NotNull;
import org.springframework.beans.factory.annotation.Required;

import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @author vmipsl
 * @date 17 feb 2011
 */
public class Controller
        extends ControllerEther
{

    /** *********************************************************** **/
    /** *********************** VIEWS ***************************** **/
    /**
     * ********************************************************** *
     */
    @ControllerMethod(view = VIEW_INIT)
    public Map<String, Object> home()
            throws WebException
    {
        return new HashMap<String, Object>();
    }

    @ControllerMethod(view = VIEW_INIT2)
    public Map<String, Object> geisaMethod()
            throws WebException
    {
        return new HashMap<String, Object>();
    }
    /** *********************************************************** **/
    /** *********************** CALLS ***************************** **/
    /**
     * ********************************************************** *
     */

    @ControllerMethod(jsonResult = true)
    //public JSONObject createUserRequest( @ParamName("fortranRequest") final String fortranRequest,  @ParamName("nbGraph") @NotNull final String nbGraph)
    //public JSONObject createUserRequest( @ParamName("fortranRequest") final String fortranRequest, @ParamName("transitionUpper") final String transitionUpper, @ParamName("transitionLower") final String transitionLower, @ParamName("nbGraph") @NotNull final String nbGraph)
    public JSONObject createUserRequest( @ParamName("fortranRequest") final String fortranRequest,
                                         @ParamName("transitionUpper") final String transitionUpper, @ParamName("transitionLower") final String transitionLower,
                                         @ParamName("nbGraph") @NotNull final String nbGraph, @ParamName("nomFichier") final String nomFichier,
                                         @ParamName("NomRepFileOut") final String NomRepFileOut)
            throws WebException
    {

        final JSONObject result = new JSONObject();

        //variable temps en milliseconde pour donner un nom unique au fichier crée
        //final Calendar calendar = Calendar.getInstance();
        //final long timeInMillis = calendar.getTimeInMillis();

        try {
            //Pour lancer le programme shell qui lance lr programme fortran

            //création d'un répertoire par requete
            final Process q = Runtime.getRuntime().exec("mkdir "+ LONG_PATH_IMAGES+NomRepFileOut);

            // Process p = Runtime.getRuntime().exec(PATH_PROCESS+"graph.sh  " + fortranRequest + " " + transitionUpper  + " " + transitionLower +" " + timeInMillis + "");
            final Process p = Runtime.getRuntime().exec(PATH_PROCESS+"graph.sh  " + fortranRequest + " " + transitionUpper  + " " + transitionLower + " " + nomFichier + " " + PATH_PROCESS+ " " + LONG_PATH_IMAGES+NomRepFileOut +"");

            //permet de connaitre le nom du dernier fichier creer (en cas de plusieurs graphs à tracer) pour tester si le dernier fichier est bien present
            //final String lastFileName = "graph" + timeInMillis +"-"+nbGraph+ ".png";
            //final String lastFileName = nomFichier +"-"+nbGraph+ ".png";
            final String lastFileName = "endFile";
            final File lastFile = new java.io.File(LONG_PATH_IMAGES+NomRepFileOut+lastFileName);
            final Integer maxTimeWait = 80000;


            //si le fichier n'exite pas  et le temps d'exécution n'est pas trop long  (inferieur a   maxTimeWait)
           Integer timeWait = 0;
           while (!lastFile .exists()  && timeWait < maxTimeWait ){
               try
                {
                    Thread.sleep(1000);
                    timeWait+=1000;

                }
                catch( InterruptedException e )
                {
                    throw new WebException(WebException.WebCode.ERROR_EXECUTION_PROCESS, e);
                }
            }

//            //filtre pour trouver le dernier fichier crée
//            final FilenameFilter lastFileNameFilter = new FilenameFilter() {
//
//                public boolean accept( final File arg0, final String arg1) {
//                    return arg1.endsWith(nbGraph+ ".png");
//                }
//            };
//
//            //(si le fichier n'exite pas ou si il existe mais la taille est nulle) et le temps d'exécution n'est pas trop long  (inferieur a   maxTimeWait)
//            Integer timeWait = 0;
//            while (( (new File(LONG_PATH_IMAGES+NomRepFileOut) != null && new File(LONG_PATH_IMAGES+NomRepFileOut).listFiles( lastFileNameFilter) != null && new File(LONG_PATH_IMAGES+NomRepFileOut).listFiles( lastFileNameFilter).length == 0) ) && timeWait < maxTimeWait ){
//                try
//                {
//                    Thread.sleep(1000);
//                    timeWait+=1000;
//
 //               }
 //               catch( InterruptedException e )
 //               {
 //                   throw new WebException(WebException.WebCode.ERROR_EXECUTION_PROCESS, e);
 //               }
 //           }

           //(si le fichier n'exite pas ou si il existe mais la taille est nulle) et le temps d'exécution n'est pas trop long  (inferieur a   maxTimeWait)
 //           Integer timeWait = 0;
 //           while ((!lastFile .exists() || (lastFile .exists()  && lastFile.length()==0)) && timeWait < maxTimeWait ){
 //               try
 //                {
 //                    Thread.sleep(1000);
 //                    timeWait+=1000;

  //               }
  //               catch( InterruptedException e )
  //               {
  //                   throw new WebException(WebException.WebCode.ERROR_EXECUTION_PROCESS, e);
  //               }
  //           }

            //filtre pour trouver tous les fichier .png dans un répertoire
            final FilenameFilter filenameFilter = new FilenameFilter() {

                public boolean accept( final File arg0, final String arg1) {
                    return arg1.endsWith(".png");
                }
            };


            final String[] filteredFileList = new File(LONG_PATH_IMAGES+NomRepFileOut).list(filenameFilter);
            final List<String> listeFichiers = Arrays.asList(filteredFileList);
            //pour trier la liste des fichiers par ordre croissant
            Collections.sort( listeFichiers );
            result.put("fileList",  listeFichiers);

            // TODO :test si les fichiers existent

            //creation d'un tar des fichiers images crees
            // final Process r = Runtime.getRuntime().exec("tar -cf "+LONG_PATH_IMAGES+"graph"+timeInMillis+"/image/GEISA.tar "+LONG_PATH_IMAGES+"graph"+timeInMillis+"/image/");


            // TODO : vérifier que le temps n'est pas écoulé et si c'est le cas retourner une erreur
            //  if(timeWait == maxTimeWait)


        }
        catch( IOException e )
        {
            throw new WebException( WebException.WebCode.PROBLEM_WITH_RUNTIME, e );
        }

        return result;
    }

//    @ControllerMethod(jsonResult = true)
//    public JSONObject transition( @ParamName("transitionValue") final String transitionValue)
//            throws WebException
//    {
//        final JSONObject result = new JSONObject();
//        try
//        {
//            final List<IsotopeG03> allIsotopeG03 = _geisaService.getAllIsotopeG03();
//            final String bob = "bib";
//        }
//        catch( ServiceException e )
//        {
//            throw new WebException( WebException.WebCode.ISOTOPE_NOT_FOUND, e );
//        }
//        return  result;
//    }

    @ControllerMethod(jsonResult = true)
    public JSONObject getTransitionByIsotopeName( @ParamName("isotopesSelectedNameArray") final String isotopesSelectedName,
                                                  @ParamName("geisaSelectedDatabase") final String geisaSelectedDatabase,
                                                  @ParamName("spectralRangeLower") final Float spectralRangeLower,
                                                  @ParamName("spectralRangeUpper") final Float spectralRangeUpper)
            throws WebException
    {
        final JSONObject result = new JSONObject();
        try
        {
            final List<String> isotopesSelectedNameList = Arrays.asList( isotopesSelectedName.split( "," ) );
//            final List<IsotopeG03> isotopeG03 = _geisaService.getTransitionsByIsotopeG03Name( isotopesSelectedNameList, spectralRangeLower, spectralRangeUpper );
            final Set<String> transitionsLower = _geisaService.getTransitionsLower( geisaSelectedDatabase, isotopesSelectedNameList, spectralRangeLower, spectralRangeUpper );
            final Set<String> transitionsUpper = _geisaService.getTransitionsUpper( geisaSelectedDatabase, isotopesSelectedNameList, spectralRangeLower, spectralRangeUpper );
            result.put( "transitionsLower", transitionsLower );
            result.put( "transitionsUpper", transitionsUpper );
        }
        catch( ServiceException e )
        {
            throw new WebException( WebException.WebCode.ISOTOPE_NOT_FOUND, e );
        }
        return  result;
    }

    @ControllerMethod(jsonResult = true)
    public JSONObject getTransitionByIsotopeNameByTransitionLower( @ParamName("isotopesSelectedNameArray") final String isotopesSelectedName,
                                                                   @ParamName("geisaSelectedDatabase") final String geisaSelectedDatabase,
                                                                   @ParamName("spectralRangeLower") final Float spectralRangeLower,
                                                                   @ParamName("spectralRangeUpper") final Float spectralRangeUpper,
                                                                   @ParamName("transitionLower") final String transitionLower)
            throws WebException
    {
        final JSONObject result = new JSONObject();
        try
        {
            //le passage de javascript à java par ajax transforme les + en espace donc (dans initGeisa-script.jsp) transformation des + en plus et dans le controller on fait l'inverse
            final String replacedTransitionLower = transitionLower.replaceAll( "plus", "+" );
            final List<String> isotopesSelectedNameList = Arrays.asList( isotopesSelectedName.split( "," ) );
            final Set<String> transitionsUpperBis = _geisaService.getTransitionsUpperByTransitionLower( geisaSelectedDatabase, isotopesSelectedNameList, spectralRangeLower, spectralRangeUpper, replacedTransitionLower );
            result.put( "transitionsUpperBis", transitionsUpperBis );
        }
        catch( ServiceException e )
        {
            throw new WebException( WebException.WebCode.ISOTOPE_NOT_FOUND, e );
        }
        return  result;
    }


    @ControllerMethod(jsonResult = true)
    public JSONObject getTransitionByIsotopeNameByTransitionUpper( @ParamName("isotopesSelectedNameArray") final String isotopesSelectedName,
                                                                   @ParamName("geisaSelectedDatabase") final String geisaSelectedDatabase,
                                                                   @ParamName("spectralRangeLower") final Float spectralRangeLower,
                                                                   @ParamName("spectralRangeUpper") final Float spectralRangeUpper,
                                                                   @ParamName("transitionUpper") final String transitionUpper)
            throws WebException
    {
        final JSONObject result = new JSONObject();
        try
        {
            final String replacedTransitionUpper = transitionUpper.replaceAll( "plus", "+" );
            final List<String> isotopesSelectedNameList = Arrays.asList( isotopesSelectedName.split( "," ) );
            final Set<String> transitionsLowerBis = _geisaService.getTransitionsUpperByTransitionUpper( geisaSelectedDatabase, isotopesSelectedNameList, spectralRangeLower, spectralRangeUpper, replacedTransitionUpper );
            result.put( "transitionsLowerBis", transitionsLowerBis );
        }
        catch( ServiceException e )
        {
            throw new WebException( WebException.WebCode.ISOTOPE_NOT_FOUND, e );
        }
        return  result;
    }


    @ControllerMethod(downloadFile = "")
    public void downloadFile( @ParamName("fileName") final String fileName, @ParamName("fileNameToDisplay") final String fileNameToDisplay )
    {
    }

    @Required
    public void setGeisaService( final GeisaService geisaService )
    {
        _geisaService = geisaService;
    }

    private static final Log LOGGER = LogFactory.getLog( Controller.class );

    public static final String PATH_IMAGES = "resources/images/graphGeisa/";
    //local
    public static final String LONG_PATH_IMAGES = "/home/npoulet/workspaces/GEISA/web/resources/images/graphGeisa/";
    //  naboo
    // public static final String LONG_PATH_IMAGES = "/usr/local/apache-tomcat/webapps/geisa/resources/images/graphGeisa/";


    //local
      public static final String PATH_PROCESS = "/home/npoulet/SauvegardePosteJussieu/homeNath/Desktop/geisa-Graphique/prog-ether/";
    //naboo et machine opérationnelle
    //public static final String PATH_PROCESS = "/home/www/GEISA/";
    private static final String VIEW_INIT = "init";
    private static final String VIEW_INIT2 = "initGeisa";

    private GeisaService _geisaService;
}